#!/usr/bin/python -OO
"""
--stefan huber, 2007-12
"""


import rect
from math import sqrt
from math import pi
from math import fabs
import math


class point:


		def __init__(self, center):
				self.x, self.y = center

		def __cmp__(self, obj):

				if not isinstance(obj, point):
					return -1

				if (self.x, self.y) < (obj.x, obj.y):
					return -1;

				elif (self.x, self.y) > (obj.x, obj.y):
					return 1;

				else:
					return 0;

		def __hash__(self):
				return hash( hash(self.x) + hash(self.y))

		def __repr__(self):
				return "circle[" + repr(self.x) + ", " + repr(self.y) + "]"

		def clone(self):
				return point((self.x, self.y))

		def coord(self):
			return self.x, self.y


		def dist (self, p):
			px, py = p
			return sqrt( (px-self.x)**2 + (py-self.y)**2 )


		def boundingBox(self):
				"""Get the bounding box"""
				x,y = self.x, self.y
				return rect.rect( x, x, y, y)

		def containsPnt( self, p, eps=0.0 ):
				"""Test if distance of points is at least eps"""
				return self.dist(p) <= eps

		def containedInBox(self, rect, eps=0.0):
				"""Test if closure of circle is contained in box"""
				return rect.containsPnt((self.x,self.y), eps)


		def intersectsBox(self, rect, eps=0.0, filled=False):
				"""Test if circle intersects with filled box. if filled is set
				the circle is thought to be a disk"""
				
				return self.containedInBox(rect, eps)


		def compIntersect( self, obj, eps=0.0):
				return obj.compIntersect(self,eps)


		def getSplittedBy(self, other, eps=0.0):
				"""Get arcs when splitting self by other"""

				return [self.clone()]




