#!/usr/bin/python -OO
"""
--stefan huber, 2007-12
"""



class rect:

		def __init__(self, left, right, bot, top):
				"""Initialize with left, right, bot and top coordinates"""

				assert( left <= right )
				assert( bot <= top )

				self.left = left
				self.right = right
				self.top = top
				self.bot = bot


		def __cmp__(self, obj):

				if (self.lb(), self.rt()) < (obj.lb(), obj.rt()):
					return -1;

				elif (self.lb(), self.rt()) > (obj.lb(), obj.rt()):
					return 1;

				else:
					return 0;

		def __hash__(self, obj):
				return hash( hash(self.left) + hash(self.right) + hash(self.bot) + hash(self.top) )

		def __repr__(self):
				return "rect[l:"+ repr(self.left) + ", r:" + repr(self.right) + ", b:" + \
						repr(self.bot) + ", t:" + repr(self.top) + "]"

		def lt(self):
				return self.left, self.top

		def rt(self):
				return self.right, self.top

		def lb(self):
				return self.left, self.bot

		def rb(self):
				return self.right, self.bot

		def width(self):
				return self.right-self.left

		def height(self):
				return self.top-self.bot

		def copy(self):
				return rect(self.left, self.right, self.bot, self.top)

		def grow(self, size):
				self.left -= size
				self.right += size
				self.bot -= size
				self.top += size
				assert( self.left <= self.right )
				assert( self.bot <= self.top )


		def boundingBox(self):
				return self.copy()

		def containsPnt( self, p, eps=0.0 ):
				"""Test if closure of rectangle contains point"""
				x, y = p

				if self.left-eps <= x <= self.right+eps and \
					self.bot-eps <= y <= self.top+eps:
					return True
				else:
					return False


		def containedInBox(self, rect, eps=0.0):
				"""Test if closure of rect is contained in box"""
				
				if rect.containsPnt(self.lt(), eps) and \
					rect.containsPnt(self.rb(), eps):
					return True
				else:
					return False


		def intersectsBox(self, rect, eps=0.0):
				"""Test if closure of rect intersects the axis aligned box"""
				
				#Rect intersects box iff rect contains a corncer point
				#of the other rect
				if self.right < rect.left - eps  or \
					self.left > rect.right + eps  or \
					self.top  < rect.bot - eps or \
					self.bot  > rect.top + eps:
					return False
				else:
					return True


def createBoundingBox(self, p1, p2):
		"""Initialize rectangle by two bounding points"""

		x1, y1 = p1
		x2, y2 = p2

		if x1 <= x2:
			left, right = x1, x2
		else:
			left, right = x2, x1

		if y1 <= y2:
			bot, top = y1, y2
		else:
			bot, top = y2, y1

		return rect(left, right, bot, top)








